#!/bin/bash

NOCOLOR='\033[0m'
GREEN='\033[0;32m'
RED='\033[0;41m'
STD='\033[0;0;39m'

flash(){
    ./flash.sh $1$2 mmcblk0p1
    exit 0
}

menu() {
    clear
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"  
    echo "         CTI FLASH         "
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"
    echo "1. Astro"
    echo "2. Elroy"
    echo "3. Orbitty"
    echo "4. Spacely"
    echo "5. Sprocket"
    echo "6. Rudi"
    echo "7. Cogswell"
    echo "8. Rosie"
    echo "9. Graphite VPX"
    echo "x. Exit"
}

astroMenu() {
    clear
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~" 
    echo "           Astro           "
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"
    echo "1. Revison G+"
    echo "2. USB3.0 (Rev F prior)"
    echo "3. mPCIe (Rev F prior)"
    echo "4. Cancel (back to main menu)"
}

elroyMenu() {
    clear
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"  
    echo "           Elroy           "
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"
    echo "1. Revison F+"
    echo "2. USB3.0 (Rev E prior)"
    echo "3. mPCIe (Rev E prior )"
    echo "4. Cancel (back to main menu)"
}

spacelyMenu() {
    clear
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"  
    echo "          Spacely          "
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"
    echo "1. Base"
    echo "2. IMX274 3 Cameras"
    echo "3. IMX274 6 Cameras"
    echo "4. IMX185 3 Cameras"
    echo "5. IMX185 6 Cameras"
    echo "4. Cancel (back to main menu)"
}

rudiMenu() {
    clear
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"  
    echo "           Rudi            "
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"
    echo "1. Revison C+"
    echo "2. USB3.0 (Rev B prior)"
    echo "3. mPCIe (Rev B prior )"
    echo "4. Cancel (back to main menu)"
}

spocketMenu() {
    clear
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"  
    echo "          Spocket          "
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"
    echo "1. Base"    
    echo "2. IMX274"
    echo "3. IMX185"
    echo "4. Cancel (back to main menu)"
}

vpgMenu() {
    clear
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"  
    echo "            VPX            "
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"
    echo "1. Base"
    echo "2. IMX274"
    echo "3. IMX185"
    echo "4. Cancel (back to main menu)"
}

tx2Menu() {
    clear
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"  
    echo "        TX2 Version        "
    echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~"
    echo "1. TX2"
    echo "2. TX2i"
    echo "3. Cancel (back to main menu)"
}


tx2Options(){
    tx2Menu
    local choice
    read -p "Enter choice:  " choice
    case $choice in
        1) flash $1;;    
        2) flash $1 -tx2i;;
        3) ;;
        *) echo -e "${RED}Invalid Choice...${STD}" && sleep 1
    esac
}



astroOptions(){
    astroMenu
    local choice
    read -p "Enter choice:  " choice
    case $choice in
        1) tx2Options astro-revG+;;    
        2) tx2Options astro-usb3;;
        3) tx2Options astro-mpcie;;
        4) ;;
        *) echo -e "${RED}Invalid Choice...${STD}" && sleep 1
    esac
}

elroyOptions(){
    elroyMenu
    local choice
    read -p "Enter choice:  " choice
    case $choice in
        1) tx2Options elroy-revF+;;    
        2) tx2Options elroy-usb3;;
        3) tx2Options elroy-mpcie;;
        4) ;;
        *) echo -e "${RED}Invalid Choice...${STD}" && sleep 1
    esac
}

spacelyOptions(){
    spacelyMenu
    local choice
    read -p "Enter choice:  " choice
    case $choice in
        1) tx2Options spacely-base;;    
        2) tx2Options spacely-imx274-3cam;;
        3) tx2Options spacely-imx274-6cam;;
        4) tx2Options spacely-imx185-3cam;;
        5) tx2Options spacely-imx185-6cam;;
        4) ;;
        *) echo -e "${RED}Invalid Choice...${STD}" && sleep 1
    esac
}

sprocketOptions(){
    spocketMenu
    local choice
    read -p "Enter choice:  " choice
    case $choice in  
        1) tx2Options sprocket;;
        2) tx2Options sprocket-imx274;;
        3) tx2Options sprocket-imx185;;
        4) ;;
        *) echo -e "${RED}Invalid Choice...${STD}" && sleep 1
    esac
}

rudiOptions(){
    rudiMenu
    local choice
    read -p "Enter choice:  " choice
    case $choice in
        1) tx2Options rudi;;    
        2) tx2Options rudi-usb3;;
        3) tx2Options rudi-mpcie;;
        4) ;;
        *) echo -e "${RED}Invalid Choice...${STD}" && sleep 1
    esac
}

vpxOptions(){
    vpxMenu
    local choice
    read -p "Enter choice:  " choice
    case $choice in  
        1) tx2Options vpg003;;
        2) tx2Options vpg003-imx274-3cam;;
        3) tx2Options vpg003-imx185-3cam;;
        4) ;;
        *) echo -e "${RED}Invalid Choice...${STD}" && sleep 1
    esac
}


boardOptions(){
    local choice
    read -p "Enter choice:  " choice
    case $choice in
        1) astroOptions;;    
        2) elroyOptions;;
        3) tx2Options orbitty;;
        4) spacelyOptions;;
        5) sprocketOptions;;
        6) rudiOptions;;
        7) cogswellOptions;;
        8) tx2Options rosie;;
        9) vpxOptions;; 
        x) exit 0;;
        *) echo -e "${RED}Invalid Choice...${STD}" && sleep 1
    esac
}
 
trap ''
dmesg -D
 
while true
do
    menu
    boardOptions
done

